<?php
/*
 * @version      1.4.2
 * @author       RBSPayment
 * @package      Jshopping
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');
require_once(__DIR__ . '/include.php');
require_once(__DIR__ . '/rbs_discount.php');

class pm_rbspayment extends PaymentRoot
{
    const VERSION = '1.4.2';
    const ORDER_APPROVED = 'approved';
    const ORDER_DECLINED = 'declined';
    const SIGNATURE_SEPARATOR = '|';
    const ORDER_SEPARATOR = ":";

    public $allowCallbacks = RBS_ENABLE_CALLBACK;

    public $currency_code2num = array(
        'USD' => '840',
        'UAH' => '980',
        'RUB' => '643',
        'RUR' => '810',
        'RON' => '946',
        'KZT' => '398',
        'KGS' => '417',
        'JPY' => '392',
        'GBR' => '826',
        'EUR' => '978',
        'CNY' => '156',
        'BYR' => '974',
        'BYN' => '933'
    );

    function showPaymentForm($params, $pmconfigs)
    {
        include(dirname(__FILE__) . "/paymentform.php");
    }

    /**
     * Данный метод отвечает за настройки плагина в админ. части
     * @param $params Параметры настроек плагина
     */
    function showAdminFormParams($params)
    {
        $module_params_array = array(
            'rbs_merchant_login',
            'rbs_merchant_password',
            'rbs_test_mode',
            'rbs_two_stage',
            'rbs_send_order',
            'rbs_tax_system',
            'transaction_end_status',
            'transaction_failed_status'
        );
        foreach ($module_params_array as $module_param) {
            if (!isset($params[$module_param]))
                $params[$module_param] = '';
        }

        $this->_loadLanguageFile();

        $rbs_taxSystems = array();
        $rbs_taxSystems[] = JHTML::_('select.option', 0, _JSHOP_RBSPAYMENT_ENTRY_TAX_SYSTEM_1, 'id', 'name');
        $rbs_taxSystems[] = JHTML::_('select.option', 1, _JSHOP_RBSPAYMENT_ENTRY_TAX_SYSTEM_2, 'id', 'name');
        $rbs_taxSystems[] = JHTML::_('select.option', 2, _JSHOP_RBSPAYMENT_ENTRY_TAX_SYSTEM_3, 'id', 'name');
        $rbs_taxSystems[] = JHTML::_('select.option', 3, _JSHOP_RBSPAYMENT_ENTRY_TAX_SYSTEM_4, 'id', 'name');
        $rbs_taxSystems[] = JHTML::_('select.option', 4, _JSHOP_RBSPAYMENT_ENTRY_TAX_SYSTEM_5, 'id', 'name');
        $rbs_taxSystems[] = JHTML::_('select.option', 5, _JSHOP_RBSPAYMENT_ENTRY_TAX_SYSTEM_6, 'id', 'name');

        $rbs_ffdVersions = array();
//        $rbs_ffdVersions[] = JHTML::_('select.option', 'v1_0', 'v1.0', 'id', 'name');
        $rbs_ffdVersions[] = JHTML::_('select.option', 'v1_05', 'v1.05', 'id', 'name');
        $rbs_ffdVersions[] = JHTML::_('select.option', 'v1_2', 'v1.2', 'id', 'name');

        $rbs_ffd_paymentMethodTypeList = array();
        $rbs_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '1', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_METHOD_1, 'id', 'name');
        $rbs_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '2', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_METHOD_2, 'id', 'name');
        $rbs_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '3', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_METHOD_3, 'id', 'name');
        $rbs_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '4', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_METHOD_4, 'id', 'name');
        $rbs_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '5', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_METHOD_5, 'id', 'name');
        $rbs_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '6', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_METHOD_6, 'id', 'name');
        $rbs_ffd_paymentMethodTypeList[] = JHTML::_('select.option', '7', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_METHOD_7, 'id', 'name');

        $rbs_ffd_paymentObjectTypeList = array();
        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '1', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_1, 'id', 'name');
        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '2', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_2, 'id', 'name');
        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '3', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_3, 'id', 'name');
        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '4', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_4, 'id', 'name');
        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '5', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_5, 'id', 'name');
//        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '6', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_6, 'id', 'name');
        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '7', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_7, 'id', 'name');
//        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '8', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_8, 'id', 'name');
        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '9', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_9, 'id', 'name');
        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '10', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_10, 'id', 'name');
//        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '11', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_11, 'id', 'name');
        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '12', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_12, 'id', 'name');
        $rbs_ffd_paymentObjectTypeList[] = JHTML::_('select.option', '13', _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_OBJECT_13, 'id', 'name');


        $orders = JModelLegacy::getInstance('orders', 'JshoppingModel');

        include dirname(__FILE__) . '/adminparamsform.php';

    }

    function showEndForm($pmconfigs, $order)
    {

        $lang = JFactory::getLanguage()->getTag();
        switch ($lang) {
            case 'en_EN':
                $lang = 'en';
                break;
            case 'ru_RU':
                $lang = 'ru';
                break;
            default:
                $lang = 'ru';
                break;
        }
        $order_id = $order->order_id;
        $description = 'Order :' . $order_id;

        $base_url = JURI::root() . 'index.php?option=com_jshopping&controller=checkout&task=step7&js_paymentclass=' . __CLASS__ . '&order_id=' . $order_id;
        $return_url = $base_url . '&rbspayment=result&act=finish';
        $fail_url = $base_url . '&act=cancel';

        $amount = round($this->_fixOrderTotal($order) * 100);
        $rbs_args = array(
            'orderNumber' => $order_id . self::ORDER_SEPARATOR . time(),
            'userName' => $pmconfigs['rbs_merchant_login'],
            'password' => $pmconfigs['rbs_merchant_password'],
            'amount' => $amount,
            'currency' => $this->currency_code2num[$order->currency_code_iso],
            'returnUrl' => $return_url,
            'failUrl' => $fail_url,
            'language' => $lang,
            'jsonParams' => json_encode(
                array(
                    'CMS:' => 'Joomla + Jshopping ',
                    'Module-Version: ' => self::VERSION,
//                        'Name' => $order_data['billing']['first_name'],
//                        'Famil' => $order_data['billing']['last_name']
                )
            ),
        );

        if ($pmconfigs['rbs_test_mode'] == 1) {
            $action_adr = RBS_TEST_URL;
        } else {
            $action_adr = RBS_PROD_URL;
        }

        // for migrate to new payment gateway
        if (defined('RBS_PROD_URL_ALT') && defined('RBS_PROD_URL_ALT_PREFIX')) {
            if (substr($pmconfigs['rbs_merchant_login'], 0, strlen(RBS_PROD_URL_ALT_PREFIX)) == RBS_PROD_URL_ALT_PREFIX) {
                $action_adr = RBS_PROD_URL_ALT;
            } else {
                //disable callbacks for old gateway version
                $this->allowCallbacks = false;
            }
        }

        if ($this->allowCallbacks === true) {//CB section update
            $callback_addresses_string = JURI::root() . 'index.php?option=com_jshopping&controller=checkout&task=step7&js_paymentclass=' . __CLASS__ . '&order_id=' . $order_id . '&rbspayment=callback&act=finish';
            $login = $pmconfigs['rbs_merchant_login'];
            $password = $pmconfigs['rbs_merchant_password'];

            if ($pmconfigs['rbs_test_mode'] == 1) {
                $gate_url = str_replace("payment/rest", "mportal-uat/mvc/public/merchant/update", $action_adr);
                // "mportal-uat" error for some ONE bank
                //$gate_url = str_replace("rest", "mportal/mvc/public/merchant/update", $action_adr);
            } else {
                $gate_url = str_replace("payment/rest", "mportal/mvc/public/merchant/update", $action_adr);
            }

            $gate_url .= substr($pmconfigs['rbs_merchant_login'], 0, -4); // we guess username = login w/o "-api"
            $headers = array(
                'Content-Type:application/json',
                'Authorization: Basic ' . base64_encode($login . ":" . $password)
            );

            $data['callbacks_enabled'] = true;
            $data['callback_addresses'] = $callback_addresses_string;
            $data['callback_operations'] = "deposited,approved,declinedByTimeout";

            $response = $this->_sendRBSData(json_encode($data), $gate_url, $headers);

            $this->_writeRBSLog($response);

        }

        if ($pmconfigs['rbs_two_stage'] == 0) {
            $action_adr .= 'register.do';
        } else {
            $action_adr .= 'registerPreAuth.do';
        }

        if ($pmconfigs['rbs_send_order'] == 1) {
//print_r($pmconfigs);die;
            $rbs_args['taxSystem'] = $pmconfigs['rbs_tax_system'];

            $order_items = $order->getAllItems();

//            $items = array();
            $itemsCnt = 1;

            // here we will collect data for orderBundle
            $orderBundle = [];

            $orderBundle['customerDetails'] = array(
                'email' => $order->email
                //'phone' => preg_match('/[7]\d{9}/', $order_info['telephone']) ? $order_info['telephone'] : ''
            );

            foreach ($order_items as $value) {
                $item = array();
                $item_tax = $value->product_tax;

                $tax_type = $this->_getTaxType($item_tax);

                $product_price = ceil($value->product_item_price * 100);

                $item['positionId'] = $itemsCnt++;
                $item['name'] = $value->product_name;

                // FFDVersion
                if ($pmconfigs['rbs_ffd_version'] == "v1_05") {
                    $item['quantity'] = array(
                        'value' => $value->product_quantity,
                        'measure' => RBS_MEASUREMENT_NAME
                    );
                }
                if ($pmconfigs['rbs_ffd_version'] == "v1_2") {
                    $item['quantity'] = array(
                        'value' => $value->product_quantity,
                        'measure' => RBS_MEASUREMENT_CODE
                    );
                }
//
//                $item['quantity'] = array(
//                    'value' => $value->product_quantity,
//                    'measure' => 'шт'
//                );
                $item['itemAmount'] = $product_price * $value->product_quantity;
                $item['itemCode'] = $value->product_id;
                $item['tax'] = array(
                    'taxType' => $tax_type
                );

                $item['itemPrice'] = $product_price;

                // FFD 1.05 added
//                if ($pmconfigs['rbs_ffd_version'] == 'v1_05') {

                $attributes = array();
                $attributes[] = array(
                    "name" => "paymentMethod",
                    "value" => $pmconfigs['rbs_ffd_paymentMethodType']
                );
                $attributes[] = array(
                    "name" => "paymentObject",
                    "value" => $pmconfigs['rbs_ffd_paymentObjectType']
                );

                $item['itemAttributes']['attributes'] = $attributes;
//                }

                $orderBundle['cartItems']['items'][] = $item;
            }

            //shipping_tax
            //order_created
            //email
            //f_name
            //l_name
            //phone


            // DISCOUNT CALCULATE (&remove delivery cost)
            if ($order->order_shipping > 0) {
                $amount -= ceil($order->order_shipping * 100);
            }
            $discountHelper = new rbsDiscount();
            $discount = $discountHelper->discoverDiscount($amount, $orderBundle['cartItems']['items']);
            if ($discount > 0) {
                $discountHelper->setOrderDiscount($discount);
                $recalculatedPositions = $discountHelper->normalizeItems($orderBundle['cartItems']['items']);
                $orderBundle['cartItems']['items'] = $recalculatedPositions;
            }


            // DELIVERY POSITION
            if ($order->order_shipping > 0) {
                $itemShipment['positionId'] = $itemsCnt;
                $itemShipment['name'] = 'Доставка';

                // FFDVersion
                if ($pmconfigs['rbs_ffd_version'] == "v1_05") {
                    $itemShipment['quantity'] = array(
                        'value' => 1,
                        'measure' => RBS_MEASUREMENT_NAME
                    );
                }
                if ($pmconfigs['rbs_ffd_version'] == "v1_2") {
                    $itemShipment['quantity'] = array(
                        'value' => 1,
                        'measure' => RBS_MEASUREMENT_CODE
                    );
                }

//                $itemShipment['quantity'] = array(
//                    'value' => 1,
//                    'measure' => 'шт'
//                );
                $itemShipment['itemAmount'] = $itemShipment['itemPrice'] = ceil($order->order_shipping * 100);
                $itemShipment['itemCode'] = 'Delivery';
                //todo
//                $itemShipment['tax'] = array(
//                    'taxType' => $this->ofd_taxType
//                );


                // FFD 1.05 added
//                if ($pmconfigs['rbs_ffd_version'] == 'v105') {

                $attributes = array();
                $attributes[] = array(
                    "name" => "paymentMethod",
                    "value" => $pmconfigs['rbs_ffd_paymentMethodType']
                );
                $attributes[] = array(
                    "name" => "paymentObject",
                    "value" => 4
                );

                $itemShipment['itemAttributes']['attributes'] = $attributes;

//                }
                $orderBundle['cartItems']['items'][] = $itemShipment;
            }

            /* Заполнение массива данных для запроса c фискализацией */
            $rbs_args['orderBundle'] = json_encode($orderBundle);
        }

        $response = $this->_sendRBSData(http_build_query($rbs_args, '', '&'), $action_adr);

        $this->_writeRBSLog("[REQUEST]: " . $action_adr . ": \nDATA: " . print_r($rbs_args, true) . "\n[RESPONSE]: " . $response);

        $response = json_decode($response, true);

        if (!empty($response['formUrl'])) {
            header("Location: " . $response['formUrl']);
            exit;
        } else {
            echo "ERROR #" . $response['errorCode'] . ": " . $response['errorMessage'];
        }

    }

    function checkTransaction($pm_config, $order, $rescode)
    {

        $this->_loadLanguageFile();
        $payment_data = JRequest::get('get');

        if ($pm_config['rbs_test_mode'] == 1) {
            $action_adr = RBS_TEST_URL;
        } else {
            $action_adr = RBS_PROD_URL;
        }

        $action_adr .= 'getOrderStatusExtended.do';
        $rbs_args = array(
            'userName' => $pm_config['rbs_merchant_login'],
            'password' => $pm_config['rbs_merchant_password'],
//            'orderId' => $rbs_order_id,
        );

        if (isset($payment_data['rbspayment'])) {
            $action = $payment_data['rbspayment'];

            switch ($action) {
                case "result":
                    $rbs_args['orderId'] = isset($payment_data['orderId']) ? $payment_data['orderId'] : null;

                    $response = $this->_sendRBSData(http_build_query($rbs_args, '', '&'), $action_adr);

                    $response = json_decode($response, true);
                    $orderStatus = $response['orderStatus'];

                    if ($orderStatus == '1' || $orderStatus == '2') {

                        $message = _JSHOP_RBSPAYMENT_ENTRY_ORDER . " " . $payment_data['order_id'] . " " . _JSHOP_RBSPAYMENT_ENTRY_WAS_PAID;
                        if ($this->allowCallbacks === false) {
                            JFactory::getApplication()->enqueueMessage($message . " " . $_REQUEST['payment_id']);
                            return array(1, _JSHOP_RBSPAYMENT_ENTRY_WAS_PAID . ' ID:' . $_REQUEST['payment_id']);
                        }

                    } else {

                        $message = _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_ERROR;
                        if ($this->allowCallbacks === false) {
                            JFactory::getApplication()->enqueueMessage($message . " " . $_REQUEST['payment_id']);
                            return array(0, $message);
                        }
                    }

                    if (!JRequest::getInt('cron', 0)) {
                        //clear cart data
                        $cart = JModelLegacy::getInstance('cart', 'jshop');
                        $cart->load();
                        $cart->clear();
                        JFactory::getApplication()->redirect("index.php?option=com_jshopping&controller=checkout&task=finish&act=return&js_paymentclass=" . __CLASS__, "" . $message);
                    }
                    die();

                    break;

                case "callback":
                    $rbs_args['orderId'] = isset($payment_data['mdOrder']) ? $payment_data['mdOrder'] : null;

                    $response = $this->_sendRBSData(http_build_query($rbs_args, '', '&'), $action_adr);

                    $response = json_decode($response, true);
                    $orderStatus = $response['orderStatus'];

                    if ($orderStatus == '1' || $orderStatus == '2') {
                        $message = _JSHOP_RBSPAYMENT_ENTRY_ORDER . " " . $payment_data['order_id'] . " " . _JSHOP_RBSPAYMENT_ENTRY_WAS_PAID;

                        JFactory::getApplication()->enqueueMessage($message . " " . $_REQUEST['payment_id']);
                        return array(1, _JSHOP_RBSPAYMENT_ENTRY_WAS_PAID . ' ID:' . $_REQUEST['payment_id']);

                    } else {

                        return array(0, _JSHOP_RBSPAYMENT_ENTRY_PAYMENT_ERROR);
                    }
                    break;
            }
        }
    }

    function getUrlParams($rbs_config)
    {
        $params = array();
        $input = JFactory::$application->input;
        $params['order_id'] = $input->getInt('order_id', null);
        $params['hash'] = "";
        $params['checkHash'] = 0;
        $params['checkReturnParams'] = 1;
        return $params;
    }

    public function _sendRBSData($data, $action_address, $headers = array())
    {

        $ch = curl_init();
        curl_setopt_array($ch, array(
            CURLOPT_HTTPHEADER => $headers,
            CURLOPT_VERBOSE => true,
            CURLOPT_SSL_VERIFYHOST => false,
            CURLOPT_SSL_VERIFYPEER => false,
            CURLOPT_URL => $action_address,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => $data,
            //                CURLOPT_ENCODING, "gzip",
        ));
        $response = curl_exec($ch);
        curl_close($ch);

        return $response;
    }

    function _writeRBSLog($var, $info = true)
    {
        $information = "";
        if ($var) {
            if ($info) {
                $information = "\n\n";
                $information .= str_repeat("-=", 64);
                $information .= "\nDate: " . date('Y-m-d H:i:s');
            }

            $result = $var;
            if (is_array($var) || is_object($var)) {
                $result = "\n" . print_r($var, true);
            }
            $result .= "\n\n";
            $path = dirname(__FILE__) . '/js_rbspayment_' . date('Y-m') . '.log';
            error_log($information . $result, 3, $path);
            return true;
        }
        return false;
    }

    function _fixOrderTotal($order)
    {
        $total = $order->order_total;
        if ($order->currency_code_iso == 'HUF') {
            $total = round($total);
        } else {
            $total = number_format($total, 2, '.', '');
        }
        return $total;
    }

    function _getTaxType($item_tax)
    {
        if ($item_tax == 20) {
            $tax_type = 6;

        } else if ($item_tax == 18) {
            $tax_type = 3;

        } else if ($item_tax == 10) {
            $tax_type = 2;

        } else if ($item_tax == 0) {
            $tax_type = 1;

        } else {
            $tax_type = 0;
        }
        return $tax_type;
    }

    function _loadLanguageFile()
    {
        $lang = JFactory::getLanguage();
        $langtag = $lang->getTag();

//        echo $langtag;
        if (file_exists(JPATH_ROOT . '/components/com_jshopping/payments/pm_rbspayment/lang/' . $langtag . '.php')) {
            require_once(JPATH_ROOT . '/components/com_jshopping/payments/pm_rbspayment/lang/' . $langtag . '.php');
        } else {
            require_once(JPATH_ROOT . '/components/com_jshopping/payments/pm_rbspayment/lang/ru-RU.php');
        }
    }
}